# Recommendation System

This system offers you the products or services that users are interested to consume. The rationale is that users of Lifelong Education Website Chiang Mai University tend to choose the same course frequently since they aren't well advertised.

## Table of Contents

- [Installation](#installation)
- [Usage](#usage)
- [Contributing](#contributing)
- [License](#license)

## Installation

To install and set up the project, you can use the following command:
```
pip install isne-recommendation
```

For detailed instructions on how to install the Study Focus Recommendation System, please navigate to our installation guide on [installation](https://isne-recommendation.gitbook.io/recommendation-system/installation). Follow the step-by-step instructions to set up the system on your machine and start enhancing your study experience today.

## Usage

After the successful installation, you can now import these functions from an isne_recommendation package:

```
from isne_recommendation import TfidfLinearKernel, FeatureRatingsKNN, Hybrid
```

Are you seeking to unravel the mysteries behind recommendation systems? Look no further! Dive into the comprehensive guide available at [usage](https://isne-recommendation.gitbook.io/recommendation-system/usage).

## Contributing

Check out our [contribution guidelines](https://isne-recommendation.gitbook.io/recommendation-system/contributing) to learn how you can get involved. Whether it's coding, documentation, testing, or providing feedback, every contribution makes a difference and helps us create a better tool for students worldwide.

## License

**License:** MIT

Please refer to the [LICENSE](LICENSE) file for more details.
